local utf8 = require("utf8")
function love.load()
    game = {
        txt = "function love.draw() \n love.graphics.print('hello world') \n end"
    },
    love.keyboard.setKeyRepeat(true)
end
function love.update(dt)
end
function love.draw()
    love.graphics.print(game.txt, 0, 0)
    if love.keyboard.isDown("escape") then
        if love.filesystem.getInfo("save.lua") then
            love.filesystem.write("save.lua", game.txt..love.filesystem.read("save.lua").."\n")
            love.event.quit()
        else
            love.filesystem.newFile("save.lua")
            love.filesystem.write(game.txt)
            love.event.quit()
        end
    end
end
function love.keypressed(key)
    if key == "return" then
        game.txt = game.txt.."\n"
    end
    if key == "backspace" then
        local byteoffset = utf8.offset(game.txt, -1)
        if byteoffset then
            game.txt = string.sub(game.txt, 1, byteoffset - 1)
        end
    end
end
function love.textinput(t)
    game.txt = game.txt..t
end
